# calc-ultra

[![GPLv3 License](https://img.shields.io/badge/License-MIT-green.svg)](https://opensource.org/license/mit/) [![Version](https://img.shields.io/badge/Version-1.3.4-blue.svg)](https://github.com/sudoer-Huatao/Calc-ULTRA_Calculus-Calculator)

> **Calculus made easy**

(Turn on dark mode for a better aesthetic)

The Calc-Ultra calculus calculator, but as a module!

- Little Python background knowledge is needed!

Supports:

- Derivatives
- Partials
- Implicit differentiation
- Antiderivatives
- Definite integrals
- Improper integrals
- Double integrals
- Solving (sets) of equation(s)
- Vector/matrix operations
- **A perfect interface to do calculations!**  

## Note

This is the module package of the Calc-Ultra calculator. For the Python script of this package, visit <https://github.com/sudoer-Huatao/Calc-ULTRA> (**unmaintained**).

## Installation and Running

> Run the calculus calculator with a single line of code

Command line: `pip3 install calc-ultra`.
Due to Python import identifiers restrictions, please import Calc-Ultra as "calc_ultra" and not "calc-ultra" when you need to use the calculator.

To run the calculator, import Calc-ULTRA as `calc_ultra` like so:

`from calc_ultra import main`

Make sure you have the latest version installed. To update calc-ultra, run `pip3 install --upgrade calc-ultra`.

## Requirements

This program requires the `sympy`,  `numpy`, `rich`, `matplotlib`, and `scipy` modules installed. Other required modules are built into most Python IDEs.

## Warnings

### Function limitations

Due to limitations of the SymPy module, **some functions cannot be integrated**. The Error Function `erf(x)` can be integrated in both indefinite integral and definite integral calculation, but the Absolute Value and Factorial functions are only available to definite integral calculations. Integration of composed functions is also limited due to SymPy limitations. While some composed functions work, others don't. 😟

## Test PYPI

Previous test versions of this project are on Test PYPI. View on <https://test.pypi.org/project/calc-ultra/>.

## Acknowledgements

> Without them, this would be impossible

A general thank-you to all GitHub users who gave feedback and/or starred this repository. ⭐️
And... a SPECIAL THANK-YOU to @Haobot for troubleshooting and feedback! 👍❤️

This program was made using SymPy and Scipy for calculation and Matplotlib and NumPy for graphing.

## Gallery

DerivaCalc derivative with graph demo:
![derivacalc_demo](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/3d99a51d-2e46-414c-8929-fa16016a856a "derivacalc_demo")

InteCalc antiderivative with graph demo:
![intecalc_demo_1](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/f61d44ae-cebf-4972-b63f-7f08ee6655b5 "intecalc_demo_1")

InteCalc definite integral with graph demo:
![intecalc_demo_2](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/b8294186-92f5-4df3-a000-d63f6fff93b0 "intecalc_demo_2")

LimCalc limit demo:
![limcalc_demo](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/12db6a7b-a836-43ce-8cef-7bcf707051f7 "limcalc_demo")

AlgCalc equation solver demo:
![algcalc_demo_1](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/e4cfa016-52bf-43b5-a839-af9f42546468 "algcalc_demo_1")

AlgCalc vector operation demo:
![algcalc_demo_2](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/7f043cb2-6b0a-4460-ab35-30f09632b1c3 "algcalc_demo_2")

AlgCalc matrix operation demo:
![algcalc_demo_3](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/a9a5d56e-424a-4ef8-beb9-a9b64ce1a3f5 "algcalc_demo_3")

## License

This project is licensed under the terms of the MIT license.
